/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include "languard_p.hpp"


bool LanGuardParser::isUsable(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument* doc)
{
	XMLCh* tmpCh = NULL;
	char *sname = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlNodes = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* xmlTempNode = NULL;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap* xmlAtt = NULL;

	tmpCh = XMLString::transcode("hosts");
	xmlNodes  = doc->getElementsByTagName(tmpCh);
    delete tmpCh;

	if(xmlNodes->getLength() == 0)
		return FALSE;
	
	xmlTempNode = xmlNodes->item(0);

	xmlAtt = xmlTempNode->getAttributes();

	if(xmlAtt == NULL)
		return FALSE;

	tmpCh = XMLString::transcode("lnss_version");
	xmlTempNode = xmlAtt->getNamedItem(tmpCh);

	if(xmlTempNode == NULL)
		return FALSE;

	// We could check the version here... but whats the fun in that?
	sname = XMLString::transcode(xmlTempNode->getNodeValue());

	delete sname;
	delete tmpCh;

	m_xmlDoc = doc;

	return TRUE;
}

bool LanGuardParser::Parse()
{
	XMLCh* tmpCh = NULL;
//	char *sname = NULL;
	int nodeCount = 0;
	
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList* xmlNodes = NULL;
	
	if(m_xmlDoc == NULL)
		return FALSE;

	tmpCh = XMLString::transcode("host");
	xmlNodes  = m_xmlDoc->getElementsByTagName(tmpCh);
	delete tmpCh;

	if(xmlNodes == NULL)
		return FALSE;


	nodeCount = xmlNodes->getLength();

	// Parse all the host nodes.
	for(int i = 0; i < nodeCount; ++i)
	{
//		m_Scan->addHost(parseHost(xmlNodes->item(i)));
	}

	return TRUE;
}

