/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_FE_UTIL
#define _H_F3_FE_UTIL

#include <string>
#include <vector>
#include <map>
#include <math.h>
#include "config.h"

#ifdef WIN32
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#ifdef _DEBUG
#include <crtdbg.h>
#define _CRTDBG_MAP_ALLOC	// For memory leak checking
#endif
#endif


using namespace std;

namespace OS_FAMILY
{
	typedef char OS;

	const OS UNKNOWN = 0;
	const OS MAC_OS = 4;
	const OS CISCO_IOS = 5;
};


#ifndef FE_DATA_DIR
#define FE_DATA_DIR "./data/"
#endif
#define FE_DATA_FILE( x ) FE_DATA_DIR #x

#endif //_H_F3_FE_UTIL
